SystemOrganization addCategory: #ConfigurationOfPastell!

Object subclass: #ConfigurationOfPastell
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPastell'!

!ConfigurationOfPastell commentStamp: '<historical>' prior: 0!
(ConfigurationOfPastell project version: #stable) load

(ConfigurationOfPastell project version: #development) load: 'Tests'!

!ConfigurationOfPastell class methodsFor: 'development support' stamp: 'AlexandreBergel 9/12/2012 11:42'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPastell class methodsFor: 'private' stamp: 'AlexandreBergel 9/12/2012 11:42'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPastell class methodsFor: 'private' stamp: 'AlexandreBergel 9/12/2012 11:42'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPastell class methodsFor: 'private' stamp: 'AlexandreBergel 9/12/2012 11:42'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPastell class methodsFor: 'metacello tool support' stamp: 'AlexandreBergel 9/12/2012 11:42'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPastell class methodsFor: 'loading' stamp: 'AlexandreBergel 9/12/2012 11:42'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPastell class methodsFor: 'loading' stamp: 'AlexandreBergel 9/12/2012 11:42'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPastell class methodsFor: 'loading' stamp: 'AlexandreBergel 9/12/2012 11:42'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPastell class methodsFor: 'accessing' stamp: 'AlexandreBergel 9/12/2012 11:42'!
project

	^self new project! !

!ConfigurationOfPastell class methodsFor: 'development support' stamp: 'AlexandreBergel 9/12/2012 11:42'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPastell methodsFor: 'baselines' stamp: 'AlexandreBergel 9/12/2012 11:42'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.squeaksource.com/Pastell'.
		spec package: 'Pastell'.
		spec group: 'default' with: #('Pastell' ). ].
! !

!ConfigurationOfPastell methodsFor: 'baselines' stamp: 'StephaneDucasse 3/3/2013 16:23'!
baseline11: spec
	<version: '1.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec description: 'Adding dependency to XMLParser'.
		spec repository: 'http://smalltalkhub.com/mc/PharoExtras/Pastell/main'.
	
	"depending on XMLParser"
	spec project: 'XMLParser'
					with: [ spec 
								className: 'ConfigurationOfXMLParser';
								versionString: #stable;
								repository: 'http://www.smalltalkhub.com/mc/PharoExtras/XMLParser/main'.].
							
	"Now we express the dependency at the package level"
	
	spec package: 'Pastell' with: [spec requires: 'XMLParser'].		
	spec group: 'default' with: #('Pastell' )
	].
! !

!ConfigurationOfPastell methodsFor: 'baselines' stamp: 'StephaneDucasse 3/12/2013 22:09'!
baseline12: spec
	<version: '1.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec description: 'With now two packages'.
		spec repository: 'http://smalltalkhub.com/mc/PharoExtras/Pastell/main'.
	
	"depending on XMLParser"
	spec project: 'XMLParser'
					with: [ spec 
								className: 'ConfigurationOfXMLParser';
								versionString: #stable;
								repository: 'http://www.smalltalkhub.com/mc/PharoExtras/XMLParser/main'.].
							
	"Now we express the dependency at the package level"
	
	spec package: 'Pastell-Base' with: [spec requires: 'XMLParser'].		
	spec package: 'Pastell-Tests' with: [ spec requires: 'Pastell-Base' ].
	spec group: 'default' with: #('Core' 'Tests' ).
	"default by default is equivalent to loading 'ALL' the packages still we added explicitly Tests to be loaded"
	spec group: 'Core' with: #('Pastell-Base' ).
	spec group: 'Tests' with: #('Pastell-Tests' )
	].
! !

!ConfigurationOfPastell methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 3/3/2013 16:31'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.3'.
! !

!ConfigurationOfPastell methodsFor: 'accessing' stamp: 'AlexandreBergel 9/12/2012 11:42'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPastell methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 3/3/2013 16:41'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.3'.
! !

!ConfigurationOfPastell methodsFor: 'versions' stamp: 'AlexandreBergel 9/12/2012 11:42'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.0 : First shoot!!'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/12/2012 11:42'.
		spec package: 'Pastell' with: 'Pastell-AlexandreBergel.21'. ].
! !

!ConfigurationOfPastell methodsFor: 'versions' stamp: 'AlexandreBergel 9/12/2012 11:43'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.0 : First shoot!!'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/12/2012 11:43'.
		spec package: 'Pastell' with: 'Pastell-AlexandreBergel.21'. ].
! !

!ConfigurationOfPastell methodsFor: 'versions' stamp: 'StephaneDucasse 3/3/2013 16:24'!
version12: spec
	<version: '1.2' imports: #('1.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'New decent baseline; before splitting the packages in two'.
		spec author: 'StephaneDucasse'.
		spec timestamp: '03/03/2013 16:43'.
		spec package: 'Pastell' with: 'Pastell-AlexandreBergel.21'. ].
! !

!ConfigurationOfPastell methodsFor: 'versions' stamp: 'StephaneDucasse 3/3/2013 16:38'!
version13: spec
	<version: '1.3' imports: #('1.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'Splitting in two packages and adding groups'.
		spec author: 'StephaneDucasse'.
		spec timestamp: '03/03/2013 16:43'.
		spec package: 'Pastell-Base' with: 'Pastell-Base-StephaneDucasse.2'. 
		spec package: 'Pastell-Tests' with: 'Pastell-Tests-AlexandreBergel.1'. ].
! !
